<template>
   <div id="left-sidebar" class="sidebar">
      <div class="">
        <div class="user-account">
            <img :src="getImage" class="rounded-circle user-photo" alt="User Profile Picture" />
            <div class="dropdown" v-bind:class="{ 'show': dropActive}"  @click="dropActive = !dropActive" v-click-outside="outside">
                <span>Welcome,</span>
                <a href="javascript:void(0);" class="dropdown-toggle user-name" data-toggle="dropdown" :aria-expanded="dropActive ? 'true' : 'false'"><strong>{{ currentUser.empName }}</strong></a>
                <ul class="dropdown-menu dropdown-menu-right account" v-bind:class="{ 'show': dropActive }" :style="dropActive ? 'top: 100%; position: absolute; transform: translate3d(-52px, 42px, 0px); left: 0px; will-change: transform;' : 'top: 80%; position: absolute; transform: translate3d(-52px, 42px, 0px); left: 0px; will-change: transform;'">
                    <li><router-link to="/pages/page-profile2"><i class="icon-user"></i>My Profile</router-link></li>
                    <li><router-link to="/app/app-inbox"><i class="icon-envelope-open"></i>Messages</router-link></li>
                    <li><a href="javascript:void(0);"><i class="icon-settings"></i>Settings</a></li>
                    <li class="divider"></li>
                    <li><a  href="" @click.prevent="logOut" class="icon-menu"><i class="icon-power"></i>Logout</a></li>
                </ul>
            </div>
            <hr>
            <ul class="row list-unstyled">
                <li class="col-4">
                    <small>Sales</small>
                    <h6>456</h6>
                </li>
                <li class="col-4">
                    <small>Order</small>
                    <h6>1350</h6>
                </li>
                <li class="col-4">
                    <small>Revenue</small>
                    <h6>$2.13B</h6>
                </li>
            </ul>
        </div> 
          <!-- Nav tabs -->
        <ul class="nav nav-tabs"  >
            <li class="nav-item" v-for="item in listmenutype" v-bind:key="item.id" >
                <a class="nav-link"  v-on:click="setActiveNavtab(item.name)" :class="{ 'active show':  openNavtab(item.name)  }" data-toggle="tab">
                    {{ item.name }} 
                </a>
            </li>
        </ul>  
          <!-- Tab panes -->
        <div class="tab-content p-l-0 p-r-0">
            <div class="tab-pane" :class="{ 'active show': openNavtab(item.name)}" :id="item.name"  v-for="item in listmenutype" v-bind:key="item.id">
                <nav id="left-sidebar-nav" class="sidebar-nav">
                    <ul id="main-menu" class="metismenu">
                         <li
                         v-for="(menuparent, index)  in listmenu.filter(menuparent => menuparent.parentID === 0 && menuparent.type === item.type)"   
                         v-bind:key="menuparent.id"   
                         v-bind:index="index"  
                         v-bind:class="{ 'active': currentActiveMenu == menuparent.link.split('/')[1] }" >
                            <a class="has-arrow" v-on:click="setActive(menuparent.link.split('/')[1])">
                                <i class="icon-home"></i> <span>{{menuparent.name}}</span>
                            </a>
                            <ul v-if="currentActiveMenu === menuparent.link.split('/')[1]" >
                                <li 
                                    v-for="(menuchild, index)  in listmenu.filter(menuchild => menuchild.parentID === menuparent.id)"   
                                    v-bind:key="menuchild.link"   
                                    v-bind:index="index"
                                    :class="{ 'active': currentRoutePath === menuchild.link}">
                                 <router-link :to="menuchild.link">{{ menuchild.name }}</router-link></li>   
                            </ul>
                        </li> 
                        <li v-bind:class="{ 'active': currentActiveMenu == 'dashboard' }">
                            <a class="has-arrow" v-on:click="setActive('dashboard')"><i class="icon-home"></i> <span>Dashboard</span></a>
                            <ul v-if="currentActiveMenu === 'dashboard'">
                                <li v-bind:class="{ 'active':currentRoutePath == '/dashboard/index'}"><router-link to="/dashboard/index" >Analytical</router-link></li>   
                                <li v-bind:class="{ 'active':currentRoutePath == '/dashboard/iot'}"><router-link to="/dashboard/iot" exact>Iot</router-link></li>                                    
                            </ul>
                        </li>

                    </ul>
                </nav>
            </div>                
        </div>
      </div>
    </div>    
</template>
<script>
 
export default {
    name: 'SidebarComponent', 
    methods:{
        changeBodycolor(color){
            this.activeColor = color
            document.body.className = 'theme-'+color+' '+ this.data_theme;
        },

        outside: function() {
            this.dropActive = false
        },

        setActive: function (menuItem) {
            if (this.currentActiveMenu === menuItem) {
                this.currentActiveMenu = null;
            } else {
                this.currentActiveMenu = menuItem;
            }
        },

        openNavtab: function (tab) {
            return this.currentMenuTab === tab
        },
        setActiveNavtab: function (tab) {
            this.currentMenuTab = tab 
        },
        setactiveTheme: function (theme) {
            this.data_theme = theme
            document.body.className = 'theme-'+this.activeColor +' '+ theme;
            Event.$emit('theme',theme) 
        },
        logOut() {
            this.$store.dispatch('auth/logout');
            this.$router.push('/authentication/page-login');
        }
    },data() {
        return {
            currentActiveMenu: window.location.pathname.split("/")[2],
            currentMenuTab: 'HR',
            activeColor: 'cyan',
            dropActive: '',
            data_theme:'',
            imagepath : this.$store.state.auth.user.user.avartar_Resize,
            listmenutype : JSON.parse(localStorage.getItem('menutype')).data,
            listmenu : JSON.parse(localStorage.getItem('menu')).data,
        }
    },directives: {
        'click-outside': {
            bind: function(el, binding) {
                // Define Handler and cache it on the element
                const bubble = binding.modifiers.bubble
                const handler = (e) => {
                    if (bubble || (!el.contains(e.target) && el !== e.target)) {
                        binding.value(e)
                    }
                }
                el.__vueClickOutside__ = handler

                // add Event Listeners
                document.addEventListener('click', handler)
            },
        }
    },computed: {
        currentRoutePath() {
            return this.$route.path;
        },
        currentUser(){
            let user = this.$store.state.auth.user.user;
            return user; 
        },
        getImage()
        {
            var src = this.imagepath;
            let path = require('@/assets/upload/min/' + src);
            return path;
        },
        showAdminBoard() {
            if (this.currentUser && this.currentUser.roles) {
                return this.currentUser.roles.includes('ROLE_ADMIN');
            }

            return false;
        },
        showModeratorBoard() { 
            if (this.currentUser && this.currentUser.roles) {
                return this.currentUser.roles.includes('ROLE_MODERATOR');
            } 
            return false;
        },
        loadmenutype(){
            let menutype = this.listmenutype
            return menutype; 
        } 
    },watch:{
        $route (){
            this.currentActiveMenu = window.location.pathname.split("/")[2];
            if (window.location.pathname.split("/")[2] ==  this.currentActiveMenu){
                document.body.className = 'theme-'+this.activeColor +' '+ this.data_theme; 
            }
        } 
    }
}
</script>
<style scoped>


</style>
